var Latch = new Class({

    Implements: Options,

    options:{
        lockOffset: 0
    },

    initialize: function(fix, stop, elements, options){
        if ($$('.flash-player')[0]) {
            // Now on index page too!
            //return;
        }
        this.LITTLE_CONTENT = false;
        var back = new Element('div', {
            'class': 'background-layer'
        });
        back.inject($$('.header')[0]);
        this.fixed = false;
        this.stoped = false;
        this._elements = elements;
        this.checkElements();
        this.elAfterStop = $$(stop)[0];
        this.elAfterFix = $$(fix)[0];
        if (this.elAfterStop) {
            this.elAfterStopPos = this.elAfterStop.getPosition().y;
            this.elAfterStopHeight = this.elAfterStop.getStyle('height').toInt();
            this.posAfterStop = this.elAfterStopPos + this.elAfterStopHeight;
            if (this.elAfterStopHeight < 400) this.LITTLE_CONTENT = true;
        }
        this.setOptions(options);
        if (this.elAfterFix) {
            this.elAfterFixPos = this.elAfterFix.getPosition().y;
            this.elAfterFixHeight = this.elAfterFix.getStyle('height').toInt();
            this.posAfterFix = this.elAfterFixPos + this.elAfterFixHeight;
        }
        this.prepareElements();
        this.attachEvents();
        this.createEmptyBlocks();
    },

    checkElements: function() {
        this._elements = this._elements.clean();
    },

    update: function() {
        this.elAfterStopPos = this.elAfterStop.getPosition().y;
        this.elAfterStopHeight = this.elAfterStop.getStyle('height').toInt();
    },

    createEmptyBlocks: function() {
        Array.each(this._elements, function(el) {
        });
    },

    prepareElements: function() {

    },

    attachEvents: function(){
        window.addEvent('scroll', function() {
            this.calcPosition();
        }.bind(this));
        window.addEvent('touchmove', function() {
            this.calcPosition();
        }.bind(this));
    },

    scrollHack: function() {
        setInterval(function () {

        }, 50);
    },

    calcPosition: function() {
        var windowScrollY = window.getScroll().y;
        var posToFix = (windowScrollY >= this.posAfterFix);
        var posToStop = (windowScrollY >= (this.posAfterStop - 600));
        if (!this.LITTLE_CONTENT) {
            if ( posToFix && !this.fixed ) {
                this.fixElements();
            }
            if ( !posToFix && this.fixed ) {
                this.unfixElements();
            }
            if ( posToStop ) {
                this.stopElements();
            }
            if ( !posToStop && this.stoped ) {
                this.startElements();
            }
        }
    },

    fixElements: function() {
        Array.each(this._elements, function(el) {
            el.addClass('mod-fixed');
        }.bind(this));
        $$('.top')[0].addClass('fix');
        if (!$$('.news>.h2')[0]) {
            $$('.top.fix')[0].setStyle('margin-bottom', 203);
        }
        this.fixed = true;
    },

    unfixElements: function() {
        Array.each(this._elements, function(el) {
            el.removeClass('mod-fixed');
        }.bind(this));
        $$('.top')[0].removeClass('fix');
        $$('.top')[0].erase('style');
        this.fixed = false;
    },

    stopElements: function() {
        var newHeight = this.elAfterStop.getStyle('height').toInt();
        if (this.elAfterStopHeight !== newHeight) {
            this.elAfterStopHeight = newHeight;
            this.posAfterStop = this.elAfterStopPos + this.elAfterStopHeight;
            return;
        }
        Array.each(this._elements, function(el) {
            el.addClass('mod-stop');
        }.bind(this));
        this.stoped = true;
    },

    startElements: function() {
        Array.each(this._elements, function(el) {
            el.removeClass('mod-stop');
        }.bind(this));
        this.stoped = false;
    }
});

window.addEvent('domready', function(){
    if (!Browser.ie6) {
        new Latch('.header', '.ajax-paginator', [$$('.news>.h2')[0], $$('.header')[0], $$('.news-calendar-layer')[0]]);
    }
});
